#ifndef CAMERA_H
#define CAMERA_H

#include <QtOpenGL/QGLWidget>
#include <QtGui/QMouseEvent>
#include <QtGui/QWheelEvent>
#include "../../src/projective.h"

using namespace Eigen;

class GLWidget : public QGLWidget
{
    Q_OBJECT

public:
    GLWidget(QWidget *parent = 0) : QGLWidget(parent) {}
    ~GLWidget()
    {
        glDeleteLists( m_sceneList, 1 );
        glDeleteLists( m_objectList, 1 );
    }

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void mousePressEvent( QMouseEvent * event );
    void mouseMoveEvent( QMouseEvent * event );
    void wheelEvent( QWheelEvent * event );

    void compileLists();

    MatrixP3d m_cameraMatrix;
    int m_objectList, m_sceneList;
    QPoint m_lastPos;
};

#endif // CAMERA_H
